///home/berryj/link/bin/genMethods "-g" "-t" "Edge" "-I" "LINK/graph/Edge.h" "-d" "graph" "-y" "display_edge" "-w" "free_edge" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Edge.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_edge(SCM, SCM, int);
void free_edge(SCM);

typedef Edge _Edge;

#define _EdgeDATA(x) ((Edge*) (EXTDATA(x)))
#define _EdgeIS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Edge >::type))
#define _EdgeISNT_DATA(x) (!_EdgeIS_DATA(x))

#define _EdgeCXX_DATA(x) (*(Edge*) (EXTDATA(VAL(x))))
#define _EdgeCXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Edge >::type))
#define _EdgeCXX_ISNT_DATA(x) (!_EdgeCXX_IS_DATA(x))


PRIMITIVE STk_init__Edge()
{
	Wrapper<_Edge>::type = STk_new_CXXwrapper_id(
			Wrapper<_Edge>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			display_edge,
			(void (*)(SCM x))0,
			(void (*)(SCM x))free_edge);
	Tcl_InitHashTable(&Register<_Edge>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_EdgeMethods(void);

PRIMITIVE STk_init_methods__Edge()
{
	genExtra_EdgeMethods();
	return UNDEFINED;
}
